import { UserData } from "../types/user";
import { useInjector, useRequest } from "vue-vulcan";
import { computed, onMounted, watch} from "vue";
import { useAuthData } from "../auth/useAuthData";

export function useContacts() {
  const { authData } = useInjector(useAuthData);
  const [ userList, getUserList ] = useRequest<UserData[]>('/getUserList', { auto: false });

  onMounted( () => {
    if(authData) getUserList();
  })

  watch(authData, val => {
    if(val) getUserList()
  })

  const contacts = computed( () => userList.value?.filter( item => item.id !== authData.value.id ))

  return {
    contacts
  }
}