import { showModal } from "@tarojs/taro";
import { useCallCenter } from "any-hooks/communication/useCallCenter";
import { watch } from "vue";
import { useInjector } from "vue-vulcan";


/** 在小程序平台监听远程联系人的呼叫动作 */
export function useCallerListener() {
  const { caller, answerCaller } = useInjector(useCallCenter);

  watch(caller, value => {
    if(caller) {
      showModal({
        title: `来自${value.nickname}的呼叫，是否接受?`,
        success: () => answerCaller('Connect'),
        fail: () => answerCaller('Hangup')
      })
    }
  })
}